//Audio, Lots and lots of audio.
datablock AudioProfile(M79ShotSound)
{
   filename    = "./M79_Fire.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79ExplosionSound)
{
   filename    = "./M79_Explosion.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79EquipSound)
{
   filename    = "./M79_Equip.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79ShellInSound)
{
   filename    = "./M79_ShellIn.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79ShellOutSound)
{
   filename    = "./M79_Shellout.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79LatchOpenSound)
{
   filename    = "./M79_Latchopen.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(M79LatchCloseSound)
{
   filename    = "./M79_Latchclosed.wav";
   description = AudioDefault3d;
   preload = true;
};

//Shell Debris
datablock DebrisData(M79ShellDebris)
{
	shapeFile = "./M79Shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};

//effects This is taken directly from the tank, However since their are edits, I didn't just set the explosion to tank shell explosion.
datablock ExplosionData(M79Explosion)
{
   explosionShape = "";
   soundProfile = M79ExplosionSound;

   lifeTimeMS = 150;

   debris = tankShellDebris;
   debrisNum = 30;
   debrisNumVariance = 10;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 140;
   debrisVelocityVariance = 50;

   particleEmitter = gravityRocketExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = gravityRocketExplosionRingEmitter;
   emitter[1] = gravityRocketExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 0 1";
   lightEndColor = "1 0 0 0";

   damageRadius = 8;
   radiusDamage = 50;

   impulseRadius = 15;
   impulseForce = 2000;

   playerBurnTime = 5000;
};

//Weapon stuff
AddDamageType("M79Direct",   '<bitmap:add-ons/Weapon_M79/CI_M79> %1',    '%2 <bitmap:add-ons/Weapon_M79/CI_M79> %1',0.2,1);
AddDamageType("M79Radius",   '<bitmap:add-ons/Weapon_M79/CIRadius_M79> %1',    '%2 <bitmap:add-ons/Weapon_M79/CIRadius_M79> %1',0.2,1);
datablock ProjectileData(M79Projectile)
{
   projectileShapeName = "./m79projectile.dts";
   directDamage        = 150;
   directDamageType    = $DamageType::M79Direct;
   radiusDamageType    = $DamageType::M79Radius;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120; //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = M79Explosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 40;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 2.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "M79 Bullet";

   explodeOnDeath = 1;
};

//Weapon
datablock ItemData(M79Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M79.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M79";
	iconName = "./Icon_M79";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = M79Image;
	canDrop = true;

   	//Ammo Guns Parameters
   	maxAmmo = 1;
   	canReload = 1;
};

//Weapon Image
datablock ShapeBaseImageData(M79Image)
{
   // Basic Item properties
   shapeFile = "./M79.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = M79Projectile;
   projectileType = Projectile;

	casing = M79ShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.15;
	stateSequence[0]			= "Activate";
	stateTransitionOnTimeout[0]     	= "LoadCheckA";
	stateSound[0]				= M79EquipSound;

	stateName[1]                    	= "Ready";
	stateTransitionOnNoAmmo[1]		= "ReloadStart";
	stateTransitionOnTriggerDown[1] 	= "Fire";
	stateAllowImageChange[1]        	= true;
	stateSequence[1]			= "ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]              	= false;
	stateSequence[2]			= "Fire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= M79shotSound;

	stateName[3] 				= "Smoke";
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.1;
	stateEmitterNode[3]			= "muzzleNode";
	stateTimeoutValue[3]            	= 0.01;
	stateTransitionOnTimeout[3]     	= "Wait";

	stateName[4]				= "Wait";
	stateTimeoutValue[4]			= 0.14;
	stateTransitionOnTimeout[4]		= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout

	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateSequence[8]                	= "Open";
	stateTimeoutValue[8]            	= 0.3;
	stateSound[8]				= M79LatchOpenSound;
	stateWaitForTimeout[8]			= true;
	stateTransitionOnTimeout[8]     	= "ReloadB";
	StatScript[8]				= "OnReloadStart";

	stateName[9]				= "ReloadB";
	stateSequence[9]                	= "ShellOut";
	stateTimeoutValue[9]            	= 0.1;
	stateSound[9]				= M79ShellOutSound;
	stateWaitForTimeout[9]			= true;
	stateTransitionOnTimeout[9]     	= "Idle";

	stateName[10]				= "Idle";
	stateSequence[10]                	= "OpenIdle";
	stateTransitionOnTimeout[10]     	= "ReloadC";
	stateTimeoutValue[10]            	= 0.2;
	stateWaitForTimeout[10]			= true;
	stateEjectShell[10]       		= true;

	stateName[11]				= "ReloadC";
	stateSequence[11]                	= "ProjectileIn";
	stateTimeoutValue[11]            	= 0.2;
	stateSound[11]				= M79ShellInSound;
	stateWaitForTimeout[11]			= true;
	stateTransitionOnTimeout[11]     	= "ReloadD";

	stateName[12]				= "ReloadD";
	stateSequence[12]                	= "Close";
	stateTimeoutValue[12]            	= 0.3;
	stateSound[12]				= M79LatchCloseSound;
	stateWaitForTimeout[12]			= true;
	stateTransitionOnTimeout[12]     	= "Ready";
	stateScript[12]				= "onReloaded";

};

function M79Image::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, shiftAway);

	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		Parent::onFire(%this,%obj,%slot);
		%obj.toolAmmo[%obj.currTool]--;
	}
	else if(%this.item.maxAmmo <= 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}
}

function M79Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M79Image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 1;
	%obj.setImageAmmo(%slot,1);
}


//I'm glad you thought I fucked something up, and decided to look in my script to make sure. 
//Or that you simply wanted to make edits.
